<template>
  <div class="operations">
    <q-page padding>
      <h6>Operations - Table of Instantiated Application Graphs</h6>
      <q-table
        :rows="operations"
        :columns="columns"
        row-key="id"
        v-if="!isLoading && !error"
      >
        <template v-slot:body="props">
          <q-tr :props="props">
            <q-td key="id" :props="props">{{ props.row.hdaGraph.id }}</q-td>
            <q-td key="description" :props="props">{{
              props.row.hdaGraph.description
            }}</q-td>
            <q-td key="designer" :props="props">{{
              props.row.hdaGraph.designer
            }}</q-td>
            <q-td key="project" :props="props">{{ props.row.project }}</q-td>
            <q-td key="status" :props="props">
              <q-avatar
                size="sm"
                text-color="white"
                :color="props.row.status === 'Running' ? 'green' : 'red'"
                :icon="props.row.status === 'Running' ? 'check' : 'close'"
              >
              </q-avatar>
            </q-td>
            <q-td key="grafanaLink" :props="props">
              <q-btn flat :href="props.row.grafana" target="_blank"
                >Grafana</q-btn
              >
            </q-td>
            <q-td key="details" :props="props">
              <q-btn flat @click="toggleDetails(props.row)">Details</q-btn>
            </q-td>
            <q-td key="action" :props="props">
              <q-btn flat color="negative" @click="stopStartGraph(props.row)">
                {{ props.row.status === 'Running' ? 'Stop' : 'Start' }}
              </q-btn>
            </q-td>
          </q-tr>
        </template>
      </q-table>

      <!-- Second Table for showing selected graph services -->
      <q-table
        class="services-table"
        v-if="selectedGraphServices.length > 0"
        :rows="selectedGraphServices"
        :columns="serviceColumns"
        row-key="name"
        dense
      >
        <template v-slot:body="serviceProps">
          <q-tr :props="serviceProps">
            <q-td key="name" :props="serviceProps">{{
              serviceProps.row.name
            }}</q-td>
            <q-td key="artifact_type" :props="serviceProps">{{
              serviceProps.row.artifact_type
            }}</q-td>
            <q-td key="cluster_affinity" :props="serviceProps">{{
              serviceProps.row.cluster_affinity
            }}</q-td>
            <q-td key="cpu" :props="serviceProps">{{
              serviceProps.row.cpu
            }}</q-td>
            <q-td key="memory" :props="serviceProps">{{
              serviceProps.row.cpu
            }}</q-td>
            <q-td key="gpu" :props="serviceProps">{{
              serviceProps.row.cpu
            }}</q-td>
            <q-td key="status" :props="serviceProps">{{
              serviceProps.row.status
            }}</q-td>
            <q-td key="grafana" :props="serviceProps">
              <q-btn flat :href="serviceProps.row.grafana" target="_blank"
                >Grafana</q-btn
              >
            </q-td>
          </q-tr>
        </template>
      </q-table>

      <div v-if="isLoading">Loading...</div>
      <div v-if="error">{{ error }}</div>
    </q-page>
  </div>
</template>

<script setup lang="ts">
import { onMounted, ref } from 'vue';
import { QPage, QTable, QTr, QTd, QBtn, QAvatar } from 'quasar';
import { useFetchOperations } from '../hooks/operations';

const {
  isLoading,
  error,
  operations,
  fetchOperations,
  startOperation,
  stopOperation,
} = useFetchOperations();
const selectedGraph = ref(null);
const selectedGraphServices = ref([]);

onMounted(() => {
  fetchOperations();
});

const columns = [
  {
    name: 'id',
    required: true,
    label: 'ID',
    align: 'left',
    field: 'id',
    sortable: true,
  },
  {
    name: 'description',
    align: 'left',
    label: 'Description',
    field: 'description',
    sortable: true,
  },
  {
    name: 'designer',
    align: 'left',
    label: 'Designer',
    field: 'designer',
    sortable: true,
  },
  {
    name: 'project',
    align: 'left',
    label: 'Project',
    field: 'project',
    sortable: true,
  },
  {
    name: 'status',
    align: 'left',
    label: 'Status',
    field: 'status',
    sortable: false,
  },
  {
    name: 'grafanaLink',
    align: 'left',
    label: 'Grafana Link',
    field: 'grafanaLink',
    sortable: false,
  },
  {
    name: 'details',
    align: 'left',
    label: 'Details',
    field: 'showDetails',
    sortable: false,
  },
  {
    name: 'action',
    align: 'left',
    label: 'Action',
    field: 'stopStart',
    sortable: false,
  },
];

const serviceColumns = ref([
  { name: 'name', label: 'Name', field: 'name' },
  { name: 'artifact_type', label: 'Type', field: 'artifact_type' },
  {
    name: 'cluster_affinity',
    label: 'Cluster Affinity',
    field: 'cluster_affinity',
  },
  { name: 'cpu', label: 'CPU', field: 'cpu' },
  { name: 'memory', label: 'Memory', field: 'memory' },
  { name: 'gpu', label: 'GPU', field: 'gpu' },
  { name: 'status', label: 'Status', field: 'status' },
  { name: 'grafana', label: 'Grafana Link', field: 'grafana', sortable: true },
]);

function toggleDetails(row) {
  if (selectedGraph.value === row.id) {
    selectedGraph.value = null;
    selectedGraphServices.value = [];
  } else {
    selectedGraph.value = row.hdaGraph.id;
    selectedGraphServices.value = Object.values(row.services);
    console.log(selectedGraphServices.value, selectedGraph.value);
  }
}


async function stopStartGraph(row) {
  if (row.status === 'Running') {
    await stopOperation(row.hdaGraph.id);
    fetchOperations();
  } else {
    await startOperation(row.hdaGraph.id);
    fetchOperations();
  }
}
</script>

<style scoped>
.operations .service-details {
  margin-top: 20px;
  gap: 40px;
}

.services-table {
  margin-top: 40px;
}
</style>
